'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

var _SidebarContext = require('../SidebarContext');

var _SidebarContext2 = _interopRequireDefault(_SidebarContext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SidebarItem = function (_Component) {
  _inherits(SidebarItem, _Component);

  function SidebarItem() {
    _classCallCheck(this, SidebarItem);

    return _possibleConstructorReturn(this, (SidebarItem.__proto__ || Object.getPrototypeOf(SidebarItem)).apply(this, arguments));
  }

  _createClass(SidebarItem, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          content = _props.content,
          dropdown = _props.dropdown,
          icon = _props.icon,
          otherProps = _objectWithoutProperties(_props, ['className', 'content', 'dropdown', 'icon']);

      var expanded = this.context.expanded;

      var classes = (0, _classnames2.default)('inloco-layout__sidebar-item', className);

      if (dropdown) {
        return _react2.default.createElement(_semanticUiReact.Dropdown.Item, _extends({
          className: classes,
          text: content,
          icon: icon ? { className: icon } : null
        }, otherProps));
      }

      var item = _react2.default.createElement(_semanticUiReact.Menu.Item, _extends({
        className: classes,
        link: true,
        content: expanded ? content : null,
        icon: icon ? { className: icon } : null
      }, otherProps));

      if (!expanded) {
        return _react2.default.createElement(_semanticUiReact.Popup, {
          inverted: true,
          size: 'tiny',
          position: 'right center',
          content: content,
          trigger: item
        });
      }
      return item;
    }
  }]);

  return SidebarItem;
}(_react.Component);

SidebarItem.propTypes = {
  className: _propTypes2.default.string,
  dropdown: _propTypes2.default.bool,
  icon: _propTypes2.default.string
};
SidebarItem.contextType = _SidebarContext2.default;
exports.default = SidebarItem;