'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SidebarSubmenuDropdown = function (_Component) {
  _inherits(SidebarSubmenuDropdown, _Component);

  function SidebarSubmenuDropdown() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, SidebarSubmenuDropdown);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = SidebarSubmenuDropdown.__proto__ || Object.getPrototypeOf(SidebarSubmenuDropdown)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      open: false
    }, _this.dropdownRef = _react2.default.createRef(), _this.getMenuStyle = function () {
      var dropdownComponent = _this.dropdownRef.current;
      var dropdownElement = dropdownComponent && dropdownComponent.ref;
      return _this.state.open && dropdownElement ? { top: dropdownElement.getBoundingClientRect().top } : null;
    }, _this.handleOpen = function () {
      _this.setState({ open: true });
    }, _this.handleClose = function () {
      _this.setState({ open: false });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(SidebarSubmenuDropdown, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          active = _props.active,
          className = _props.className,
          children = _props.children,
          icon = _props.icon,
          content = _props.content,
          otherProps = _objectWithoutProperties(_props, ['active', 'className', 'children', 'icon', 'content']);

      var open = this.state.open;

      var classes = (0, _classnames2.default)('inloco-layout__sidebar-submenu-dropdown', className, {
        activeSubMenu: active
      });

      var dropdown = _react2.default.createElement(
        _semanticUiReact.Dropdown,
        _extends({
          ref: this.dropdownRef,
          className: classes,
          item: true,
          icon: { className: icon },
          onOpen: this.handleOpen,
          onClose: this.handleClose
        }, otherProps),
        _react2.default.createElement(
          _semanticUiReact.Dropdown.Menu,
          { style: this.getMenuStyle() },
          _react2.default.createElement(_semanticUiReact.Dropdown.Header, { content: content }),
          _react2.default.Children.map(children, function (child) {
            return _react2.default.cloneElement(child, { dropdown: true });
          })
        )
      );

      // We don't want to keep showing the tooltip when the dropdown is
      // open. This css class is the simplest way of achieving that.
      var popupClasses = (0, _classnames2.default)({ 'inloco-popup--hidden': open });
      return _react2.default.createElement(_semanticUiReact.Popup, {
        className: popupClasses,
        inverted: true,
        size: 'tiny',
        position: 'right center',
        content: content,
        trigger: dropdown
      });
    }

    /**
     * Calculates the menu's top position when the dropdown opens.
     * Usually this wouldn't be necessary, as the menu uses absolute position, so it can
     * handled by CSS automatically. But the sidebar has a vertical scroll, so this
     * doesn't work as expected anymore. We could change it to use fixed position, but
     * it was even harder to make it work that way, due to some fixed elements on the page,
     * such as the sidebar header. Controlling it via js was the simplest approach with the
     * best results.
     *
     * For more information on this problem: https://css-tricks.com/popping-hidden-overflow/.
     */

  }]);

  return SidebarSubmenuDropdown;
}(_react.Component);

SidebarSubmenuDropdown.propTypes = {
  active: _propTypes2.default.bool,
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  content: _propTypes2.default.node.isRequired,
  icon: _propTypes2.default.string.isRequired
};
exports.default = SidebarSubmenuDropdown;